Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config0.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config0.cfg	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config0.cfg	(revision 77)
@@ -9,6 +9,4 @@
 16	16	*2	# nb_general_register
 2 	2 	+1	# nb_special_register
-40	40	+1	# nb_operation       
-6	6	+1	# nb_type            
 4	4	*2	# nb_gpr_write
 2	2	*2	# nb_spr_write
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config1.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config1.cfg	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config1.cfg	(revision 77)
@@ -9,6 +9,4 @@
 4 	4 	*2	# nb_general_register
 4 	4 	+1	# nb_special_register
-40	40	+1	# nb_operation       
-6	6	+1	# nb_type            
 2	4	*2	# nb_gpr_write
 2	4	*2	# nb_spr_write
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config2.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config2.cfg	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config2.cfg	(revision 77)
@@ -9,6 +9,4 @@
 4 	4 	*2	# nb_general_register
 4 	4 	+1	# nb_special_register
-40	40	+1	# nb_operation       
-6	6	+1	# nb_type            
 1	1	*2	# nb_gpr_write
 1	1	*2	# nb_spr_write
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config_min.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config_min.cfg	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/config_min.cfg	(revision 77)
@@ -9,6 +9,4 @@
 32	32	*2	# nb_general_register
 32	32	+1	# nb_special_register
-12	12	+1	# nb_operation       
-5 	5 	+1	# nb_type            
 1 	1 	*2	# nb_gpr_write
 1 	1 	*2	# nb_spr_write
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/main.cpp	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/src/main.cpp	(revision 77)
@@ -8,5 +8,5 @@
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/SelfTest/include/test.h"
 
-#define NB_PARAMS 15
+#define NB_PARAMS 13
 
 void usage (int argc, char * argv[])
@@ -23,6 +23,4 @@
        << " - nb_general_register (unsigned int)" << endl
        << " - nb_special_register (unsigned int)" << endl
-       << " - nb_operation        (unsigned int)" << endl
-       << " - nb_type             (unsigned int)" << endl
        << " - nb_gpr_write        (unsigned int)" << endl
        << " - nb_spr_write        (unsigned int)" << endl
@@ -58,6 +56,4 @@
   const uint32_t nb_general_register = atoi(argv[x++]);
   const uint32_t nb_special_register = atoi(argv[x++]);
-  const uint32_t nb_operation        = atoi(argv[x++]);
-  const uint32_t nb_type             = atoi(argv[x++]);
   const uint32_t nb_gpr_write        = atoi(argv[x++]);
   const uint32_t nb_spr_write        = atoi(argv[x++]);
@@ -77,6 +73,4 @@
 	 ,nb_general_register
 	 ,nb_special_register
-	 ,nb_operation       
-	 ,nb_type            
 	 ,nb_gpr_write
 	 ,nb_spr_write
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/include/Parameters.h	(revision 77)
@@ -37,6 +37,4 @@
   public : const uint32_t    _nb_general_register  ;
   public : const uint32_t    _nb_special_register  ;
-  public : const uint32_t    _nb_operation         ;
-  public : const uint32_t    _nb_type              ;
   public : const uint32_t    _nb_gpr_write         ;
   public : const uint32_t    _nb_spr_write         ;
@@ -52,6 +50,4 @@
   public : const uint32_t    _size_general_register;
   public : const uint32_t    _size_special_register;
-  public : const uint32_t    _size_operation       ;
-  public : const uint32_t    _size_type            ;
 
   public : const bool        _have_port_context_id   ;
@@ -72,6 +68,4 @@
 			uint32_t nb_general_register,
 			uint32_t nb_special_register,
-			uint32_t nb_operation       ,
-			uint32_t nb_type            ,
 			uint32_t nb_gpr_write       ,
 			uint32_t nb_spr_write       ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters.cpp	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters.cpp	(revision 77)
@@ -27,6 +27,4 @@
 			  uint32_t nb_general_register,
 			  uint32_t nb_special_register,
-			  uint32_t nb_operation       ,
-			  uint32_t nb_type            ,
 			  uint32_t nb_gpr_write       ,
 			  uint32_t nb_spr_write       ,
@@ -42,6 +40,4 @@
     _nb_general_register   (nb_general_register  ),
     _nb_special_register   (nb_special_register  ),
-    _nb_operation          (nb_operation         ),
-    _nb_type               (nb_type              ),
     _nb_gpr_write          (nb_gpr_write         ),
     _nb_spr_write          (nb_spr_write         ),
@@ -57,6 +53,4 @@
     _size_general_register (static_cast<uint32_t>(log2(_nb_general_register))),
     _size_special_register (static_cast<uint32_t>(log2(_nb_special_register))),
-    _size_operation        (static_cast<uint32_t>(log2(_nb_operation       ))),
-    _size_type             (static_cast<uint32_t>(log2(_nb_type            ))),
 
     _have_port_context_id    (_size_context_id    > 0),
@@ -104,6 +98,4 @@
     _nb_general_register   (param._nb_general_register   ),
     _nb_special_register   (param._nb_special_register   ),
-    _nb_operation          (param._nb_operation          ),
-    _nb_type               (param._nb_type               ),
     _nb_gpr_write          (param._nb_gpr_write          ),
     _nb_spr_write          (param._nb_spr_write          ),
@@ -119,6 +111,4 @@
     _size_general_register (param._size_general_register ),
     _size_special_register (param._size_special_register ),
-    _size_operation        (param._size_operation        ),
-    _size_type             (param._size_type             ),
 
     _have_port_context_id    (param._have_port_context_id   ),
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters_print.cpp	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Parameters_print.cpp	(revision 77)
@@ -35,6 +35,4 @@
     xml.singleton_begin("nb_general_register"); xml.attribut("value",toString(_nb_general_register)); xml.singleton_end();
     xml.singleton_begin("nb_special_register"); xml.attribut("value",toString(_nb_special_register)); xml.singleton_end();
-    xml.singleton_begin("nb_operation       "); xml.attribut("value",toString(_nb_operation       )); xml.singleton_end();
-    xml.singleton_begin("nb_type            "); xml.attribut("value",toString(_nb_type            )); xml.singleton_end();
     xml.singleton_begin("nb_gpr_write       "); xml.attribut("value",toString(_nb_gpr_write       )); xml.singleton_end();
     xml.singleton_begin("nb_spr_write       "); xml.attribut("value",toString(_nb_spr_write       )); xml.singleton_end();
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/configuration_multi_port_bypass_memory.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/configuration_multi_port_bypass_memory.cfg	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/configuration_multi_port_bypass_memory.cfg	(revision 77)
@@ -10,6 +10,4 @@
 16 	16 	*2	# nb_general_register
 8 	8 	+1	# nb_special_register
-8	8	+1	# nb_operation       
-4	4	+1	# nb_type            
 1	1	*2	# nb_gpr_write
 1	1	*2	# nb_spr_write
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/configuration_multi_port_bypass_write.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/configuration_multi_port_bypass_write.cfg	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/configuration_multi_port_bypass_write.cfg	(revision 77)
@@ -10,6 +10,4 @@
 16 	16     	*2	# nb_general_register
 8 	8 	+1	# nb_special_register
-8	8	+1	# nb_operation       
-4	4	+1	# nb_type            
 1	1	*2	# nb_gpr_write
 1	1	*2	# nb_spr_write
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/configuration_multi_port_retire2.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/configuration_multi_port_retire2.cfg	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/configuration_multi_port_retire2.cfg	(revision 77)
@@ -10,6 +10,4 @@
 18   	16 	*2	# nb_general_register
 8 	8 	+1	# nb_special_register
-8	8	+1	# nb_operation       
-4	4	+1	# nb_type            
 1	1	*2	# nb_gpr_write
 1	1	*2	# nb_spr_write
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/configuration_multi_port_retire4.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/configuration_multi_port_retire4.cfg	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/configuration_multi_port_retire4.cfg	(revision 77)
@@ -10,6 +10,4 @@
 16	16	*2	# nb_general_register
 8 	8	+1	# nb_special_register
-8	8	+1	# nb_operation       
-4	4	+1	# nb_type            
 1 	1	*2	# nb_gpr_write
 1	1	*2	# nb_spr_write
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/configuration_multi_port_write.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/configuration_multi_port_write.cfg	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/configuration_multi_port_write.cfg	(revision 77)
@@ -10,6 +10,4 @@
 16 	16 	*2	# nb_general_register
 8 	8 	+1	# nb_special_register
-8	8	+1	# nb_operation       
-4	4	+1	# nb_type            
 2	4	*2	# nb_gpr_write
 2	4	*2	# nb_spr_write
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/src/main.cpp	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/src/main.cpp	(revision 77)
@@ -8,5 +8,5 @@
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/include/test.h"
 
-#define NB_PARAMS 18
+#define NB_PARAMS 16
 
 void usage (int argc, char * argv[])
@@ -24,6 +24,4 @@
        << " - nb_general_register (unsigned int)" << endl
        << " - nb_special_register (unsigned int)" << endl
-       << " - nb_operation        (unsigned int)" << endl
-       << " - nb_type             (unsigned int)" << endl
        << " - nb_gpr_write        (unsigned int)" << endl
        << " - nb_spr_write        (unsigned int)" << endl
@@ -62,6 +60,4 @@
   const uint32_t nb_general_register = atoi(argv[x++]);
   const uint32_t nb_special_register = atoi(argv[x++]);
-  const uint32_t nb_operation        = atoi(argv[x++]);
-  const uint32_t nb_type             = atoi(argv[x++]);
   const uint32_t nb_gpr_write        = atoi(argv[x++]);
   const uint32_t nb_spr_write        = atoi(argv[x++]);
@@ -84,6 +80,4 @@
 	 ,nb_general_register
 	 ,nb_special_register
-	 ,nb_operation       
-	 ,nb_type            
 	 ,nb_gpr_write
 	 ,nb_spr_write
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Parameters.h	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Parameters.h	(revision 77)
@@ -36,6 +36,4 @@
   public : const uint32_t    _nb_general_register  ;
   public : const uint32_t    _nb_special_register  ;
-  public : const uint32_t    _nb_operation         ;
-  public : const uint32_t    _nb_type              ;
   public : const uint32_t    _nb_gpr_write         ;
   public : const uint32_t    _nb_spr_write         ;
@@ -59,6 +57,4 @@
   public : const uint32_t    _size_general_register;
   public : const uint32_t    _size_special_register;
-  public : const uint32_t    _size_operation       ;
-  public : const uint32_t    _size_type            ;
 
   public : const bool        _have_port_context_id   ;
@@ -78,6 +74,4 @@
 			uint32_t nb_general_register,
 			uint32_t nb_special_register,
-			uint32_t nb_operation       ,
-			uint32_t nb_type            ,
 			uint32_t nb_gpr_write       ,
 			uint32_t nb_spr_write       ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters.cpp	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters.cpp	(revision 77)
@@ -30,6 +30,4 @@
 			  uint32_t nb_general_register,
 			  uint32_t nb_special_register,
-			  uint32_t nb_operation       ,
-			  uint32_t nb_type            ,
 			  uint32_t nb_gpr_write       ,
 			  uint32_t nb_spr_write       ,
@@ -48,6 +46,4 @@
     _nb_general_register   (nb_general_register  ),
     _nb_special_register   (nb_special_register  ),
-    _nb_operation          (nb_operation         ),
-    _nb_type               (nb_type              ),
     _nb_gpr_write          (nb_gpr_write         ),
     _nb_spr_write          (nb_spr_write         ),
@@ -63,6 +59,4 @@
     _size_general_register (static_cast<uint32_t>(log2(_nb_general_register))),
     _size_special_register (static_cast<uint32_t>(log2(_nb_special_register))),
-    _size_operation        (static_cast<uint32_t>(log2(_nb_operation       ))),
-    _size_type             (static_cast<uint32_t>(log2(_nb_type            ))),
 
     _have_port_context_id    (_size_context_id    > 0),
@@ -89,6 +83,4 @@
     _nb_general_register   (param._nb_general_register   ),
     _nb_special_register   (param._nb_special_register   ),
-    _nb_operation          (param._nb_operation          ),
-    _nb_type               (param._nb_type               ),
     _nb_gpr_write          (param._nb_gpr_write          ),
     _nb_spr_write          (param._nb_spr_write          ),
@@ -104,6 +96,4 @@
     _size_general_register (param._size_general_register ),
     _size_special_register (param._size_special_register ),
-    _size_operation        (param._size_operation        ),
-    _size_type             (param._size_type             ),
 
     _have_port_context_id    (param._have_port_context_id   ),
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters_print.cpp	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters_print.cpp	(revision 77)
@@ -38,6 +38,4 @@
     xml.singleton_begin("nb_general_register"); xml.attribut("value",toString(_nb_general_register)); xml.singleton_end();
     xml.singleton_begin("nb_special_register"); xml.attribut("value",toString(_nb_special_register)); xml.singleton_end();
-    xml.singleton_begin("nb_operation       "); xml.attribut("value",toString(_nb_operation       )); xml.singleton_end();
-    xml.singleton_begin("nb_type            "); xml.attribut("value",toString(_nb_type            )); xml.singleton_end();
     xml.singleton_begin("nb_gpr_write       "); xml.attribut("value",toString(_nb_gpr_write       )); xml.singleton_end();
     xml.singleton_begin("nb_spr_write       "); xml.attribut("value",toString(_nb_spr_write       )); xml.singleton_end();
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/SelfTest/configuration.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/SelfTest/configuration.cfg	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/SelfTest/configuration.cfg	(revision 77)
@@ -10,6 +10,4 @@
 64	64	*2	# nb_general_register     
 16	16	*2	# nb_special_register     
-10	10	*2	# nb_operation            
-4	4	*2	# nb_type                 
 2	2	*2	# nb_gpr_write            
 2	2	*2	# nb_spr_write            
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/SelfTest/src/main.cpp	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/SelfTest/src/main.cpp	(revision 77)
@@ -8,5 +8,5 @@
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/SelfTest/include/test.h"
 
-#define NB_PARAMS 19
+#define NB_PARAMS 17
 
 void usage (int argc, char * argv[])
@@ -24,6 +24,4 @@
   err (_(" * nb_general_register      (uint32_t)\n"));
   err (_(" * nb_special_register      (uint32_t)\n"));
-  err (_(" * nb_operation             (uint32_t)\n"));
-  err (_(" * nb_type                  (uint32_t)\n"));
   err (_(" * nb_gpr_write             (uint32_t)\n"));
   err (_(" * nb_spr_write             (uint32_t)\n"));
@@ -59,6 +57,4 @@
   const uint32_t    _nb_general_register      = atoi(argv[x++]);
   const uint32_t    _nb_special_register      = atoi(argv[x++]);
-  const uint32_t    _nb_operation             = atoi(argv[x++]);
-  const uint32_t    _nb_type                  = atoi(argv[x++]);
   const uint32_t    _nb_gpr_write             = atoi(argv[x++]);
   const uint32_t    _nb_spr_write             = atoi(argv[x++]);
@@ -83,6 +79,4 @@
 	 _nb_general_register     ,
 	 _nb_special_register     ,
-	 _nb_operation            ,
-	 _nb_type                 ,
 	 _nb_gpr_write            ,
 	 _nb_spr_write            ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Parameters.h	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/include/Parameters.h	(revision 77)
@@ -36,6 +36,4 @@
   public : const uint32_t    _nb_general_register     ;
   public : const uint32_t    _nb_special_register     ;
-  public : const uint32_t    _nb_operation            ;
-  public : const uint32_t    _nb_type                 ;
   public : const uint32_t    _nb_gpr_write            ;
   public : const uint32_t    _nb_spr_write            ;
@@ -54,6 +52,4 @@
   public : const uint32_t    _size_general_register   ;
   public : const uint32_t    _size_special_register   ;
-  public : const uint32_t    _size_operation          ;
-  public : const uint32_t    _size_type               ;
 
   public : const bool        _have_port_context_id    ;
@@ -76,6 +72,4 @@
 			uint32_t nb_general_register     ,
 			uint32_t nb_special_register     ,
-			uint32_t nb_operation            ,
-			uint32_t nb_type                 ,
 			uint32_t nb_gpr_write            ,
 			uint32_t nb_spr_write            ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters.cpp	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters.cpp	(revision 77)
@@ -29,6 +29,4 @@
 			  uint32_t nb_general_register     ,
 			  uint32_t nb_special_register     ,
-			  uint32_t nb_operation            ,
-			  uint32_t nb_type                 ,
 			  uint32_t nb_gpr_write            ,
 			  uint32_t nb_spr_write            ,
@@ -48,6 +46,4 @@
     _nb_general_register      (nb_general_register     ),
     _nb_special_register      (nb_special_register     ),
-    _nb_operation             (nb_operation            ),
-    _nb_type                  (nb_type                 ),
     _nb_gpr_write             (nb_gpr_write            ),
     _nb_spr_write             (nb_spr_write            ),
@@ -66,6 +62,4 @@
     _size_general_register    (log2(nb_general_register)),
     _size_special_register    (log2(nb_special_register)),
-    _size_operation           (log2(nb_operation       )),
-    _size_type                (log2(nb_type            )),
     
     _have_port_context_id     (_size_context_id   >0),
@@ -86,6 +80,4 @@
 	,_nb_general_register
 	,_nb_special_register
-	,_nb_operation       
-	,_nb_type            
 	,_nb_gpr_write
 	,_nb_spr_write
@@ -105,6 +97,4 @@
 	 ,nb_general_register
 	 ,nb_special_register
-	 ,nb_operation       
-	 ,nb_type            
 	 ,nb_gpr_write
 	 ,nb_spr_write
@@ -134,6 +124,4 @@
     _nb_general_register      (param._nb_general_register     ),
     _nb_special_register      (param._nb_special_register     ),
-    _nb_operation             (param._nb_operation            ),
-    _nb_type                  (param._nb_type                 ),
     _nb_gpr_write             (param._nb_gpr_write            ),
     _nb_spr_write             (param._nb_spr_write            ),
@@ -152,6 +140,4 @@
     _size_general_register    (param._size_general_register   ),
     _size_special_register    (param._size_special_register   ),
-    _size_operation           (param._size_operation          ),
-    _size_type                (param._size_type               ),
 
     _have_port_context_id     (param._have_port_context_id    ),
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters_print.cpp	(revision 76)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/src/Parameters_print.cpp	(revision 77)
@@ -37,6 +37,4 @@
     xml.singleton_begin("nb_general_register     "); xml.attribut("value",toString(_nb_general_register     )); xml.singleton_end();
     xml.singleton_begin("nb_special_register     "); xml.attribut("value",toString(_nb_special_register     )); xml.singleton_end();
-    xml.singleton_begin("nb_operation            "); xml.attribut("value",toString(_nb_operation            )); xml.singleton_end();
-    xml.singleton_begin("nb_type                 "); xml.attribut("value",toString(_nb_type                 )); xml.singleton_end();
     xml.singleton_begin("nb_gpr_write            "); xml.attribut("value",toString(_nb_gpr_write            )); xml.singleton_end();
     xml.singleton_begin("nb_spr_write            "); xml.attribut("value",toString(_nb_spr_write            )); xml.singleton_end();